zoukankan      html  css  js  c++  java
  • CodeForces 886B Vlad and Cafes (水题)

    Vlad likes to eat in cafes very much. During his life, he has visited cafes n times. Unfortunately, Vlad started to feel that his last visits are not any different from each other. To fix that Vlad had a small research.

    First of all, Vlad assigned individual indices to all cafes. Then, he wrote down indices of cafes he visited in a row, in order of visiting them. Now, Vlad wants to find such a cafe that his last visit to that cafe was before his last visits to every other cafe. In other words, he wants to find such a cafe that he hasn't been there for as long as possible. Help Vlad to find that cafe.

    Input
    In first line there is one integer n (1 ≤ n ≤ 2·105) — number of cafes indices written by Vlad.

    In second line, n numbers a1, a2, ..., an (0 ≤ ai ≤ 2·105) are written — indices of cafes in order of being visited by Vlad. Vlad could visit some cafes more than once. Note that in numeration, some indices could be omitted.

    Output
    Print one integer — index of the cafe that Vlad hasn't visited for as long as possible.

    Example
    Input
    5
    1 3 2 1 2
    Output
    3
    Input
    6
    2 1 2 2 4 1
    Output
    2
    Note
    In first test, there are three cafes, and the last visits to cafes with indices 1 and 2 were after the last visit to cafe with index 3; so this cafe is the answer.

    In second test case, there are also three cafes, but with indices 1, 2 and 4. Cafes with indices 1 and 4 were visited after the last visit of cafe with index 2, so the answer is 2. Note that Vlad could omit some numbers while numerating the cafes.

    题意:

    英语是硬伤。。给出咖啡馆的指数,访问咖啡馆按照时间的顺序。让你求最后一次去某个咖啡馆的时间最早,输出咖啡馆的指数。

    题解:

    记录更新每个咖啡馆的最后一次访问时间,然后输出访问时间最小的那个就行了。

    #include<iostream>
    #include<cstring>
    #include<algorithm>
    using namespace std;
    const int maxn=2e5+5,INF=0x3f3f3f3f;
    int a[maxn];
    int last[maxn];
    int main()
    {
        int n;
        while(cin>>n)
        {
            memset(last,INF,sizeof(last));
            for(int i=0;i<n;i++)
            {
                cin>>a[i];
                last[a[i]]=i;
            }
            sort(last,last+maxn);
            cout<<a[last[0]]<<endl;
        }
        return 0;
    }
    
  • 相关阅读:
    【POJ 3162】 Walking Race (树形DP-求树上最长路径问题,+单调队列)
    【POJ 2152】 Fire (树形DP)
    【POJ 1741】 Tree (树的点分治)
    【POJ 2486】 Apple Tree (树形DP)
    【HDU 3810】 Magina (01背包,优先队列优化,并查集)
    【SGU 390】Tickets (数位DP)
    【SPOJ 2319】 BIGSEQ
    【SPOJ 1182】 SORTBIT
    【HDU 5456】 Matches Puzzle Game (数位DP)
    【HDU 3652】 B-number (数位DP)
  • 原文地址:https://www.cnblogs.com/orion7/p/7879311.html
Copyright © 2011-2022 走看看